on startMovieWin
  global gPathName, gLastTimeRollover, gPanoFrame, gPanoCallbackFactory, gTestCallbackFactory, gQTVRCallBackFactory
  set gPathName to EMPTY
  set gLastTimeRollover to 0
  set gPanoFrame to EMPTY
  openXLib("QTVRW.QTC")
  set tInitObj to QTVRW(mnew, "Nav")
  if objectp(tInitObj) then
    tInitObj(mdispose)
  end if
  set gPanoCallbackFactory to SampleCallbacks(mnew)
  set gTestCallbackFactory to TestCallbacks(mnew)
end

on stopMovieWin
  global gPanoCallbackFactory, gTestCallbackFactory
  ClosePanoMovieD()
  closeXLib("QTVRW.QTC")
  if objectp(gPanoCallbackFactory) then
    gPanoCallbackFactory(mdispose)
  end if
  if objectp(gTestCallbackFactory) then
    gTestCallbackFactory(mdispose)
  end if
end

on OpenPanoMovieD pFileName, pSpriteNum, pShowOnOpen
  global gPanoMovieObj, gPathName, fileName, gQTVRok
  ClosePanoMovieD()
  set gPanoMovieObj to QTVRW(mnew, "Pan")
  if not objectp(gPanoMovieObj) then
    put "Unable to create new Pan instance"
    beep()
    exit
  end if
  set tResultCode to gPanoMovieObj(mOpenMovie, fileName, "115, 43")
  if tResultCode = 0 then
    put "Unable to open panomovie"
    gPanoMovieObj(mdispose)
    beep()
    exit
  end if
  set gQTVRok to 1
  set gPathName to ExtractPathName(pFileName)
  InitPanoCallbacksD()
  if pShowOnOpen then
    gPanoMovieObj(mUpdate)
  end if
end

on InitPanoCallbacksD
  global gPanoMovieObj, gPanoCallbackFactory
  if objectp(gPanoMovieObj) and objectp(gPanoCallbackFactory) then
    gPanoMovieObj(mSetMouseOverCallback, gPanoCallbackFactory, EMPTY)
    gPanoMovieObj(mSetRolloverCallback, gPanoCallbackFactory, "SampleRolloverHandlerD")
    gPanoMovieObj(mSetMouseDownCallback, gPanoCallbackFactory, EMPTY)
    gPanoMovieObj(mSetPanZoomStartCallback, gPanoCallbackFactory, EMPTY)
    gPanoMovieObj(mSetMouseStillDownCallback, gPanoCallbackFactory, EMPTY)
    gPanoMovieObj(mSetNodeLeaveCallback, gPanoCallbackFactory, EMPTY)
  end if
end

on ShowPanoMovie pQuality
  global gPanoMovieObj
  if objectp(gPanoMovieObj) then
    if not voidp(pQuality) then
      gPanoMovieObj(mSetQuality, string(pQuality))
    end if
    gPanoMovieObj(mUpdate)
  end if
end

on SetPanoNodeD pNodeID, pUpdate, pQuality
  global gPanoMovieObj
  if objectp(gPanoMovieObj) then
    if not voidp(pNodeID) then
      gPanoMovieObj(mSetNodeID, integer(pNodeID))
    end if
    if not voidp(pQuality) then
      gPanoMovieObj(mSetQuality, string(pQuality))
    end if
    if pUpdate then
      gPanoMovieObj(mUpdate)
    end if
  end if
end

on SwingPanoMovieD pHPan, pVPan, pZoom, pSwingSpeed, pSwingQuality, pFinalQuality
  global gPanoMovieObj
  if objectp(gPanoMovieObj) then
    gPanoMovieObj(mSetZoomAngle, string(pZoom))
    gPanoMovieObj(mSetVPanAngle, string(pVPan))
    gPanoMovieObj(mSetHPanAngle, string(pHPan))
    gPanoMovieObj(mSetQuality, string(pSwingQuality))
    gPanoMovieObj(mSetTransitionMode, "swing")
    gPanoMovieObj(mSetTransitionSpeed, string(pSwingSpeed))
    gPanoMovieObj(mUpdate)
    gPanoMovieObj(mSetTransitionMode, "normal")
    if pFinalQuality <> pSwingQuality then
      gPanoMovieObj(mSetQuality, string(pSwingQuality))
      gPanoMovieObj(mUpdate)
    end if
  end if
end

on SetPanoMovieViewD pHPan, pVPan, pZoom, pQuality
  global gPanoMovieObj
  if objectp(gPanoMovieObj) then
    gPanoMovieObj(mSetZoomAngle, string(pZoom))
    gPanoMovieObj(mSetVPanAngle, string(pVPan))
    gPanoMovieObj(mSetHPanAngle, string(pHPan))
    if not voidp(pQuality) then
      gPanoMovieObj(mSetQuality, string(pQuality))
    end if
    gPanoMovieObj(mUpdate)
  end if
end

on ClosePanoMovieD
  global gPanoMovieObj
  if objectp(gPanoMovieObj) then
    gPanoMovieObj(mdispose)
  end if
end

on PanoFrameScriptD pSpriteNum
  global gLastTimeRollover, currHSID, currNID, gInfo, gPanoMovieObj, gLastPanoMovieData, gPathName, gNavMovieObj, gPanoFrame
  set gInfo to 0
  if rollOver(pSpriteNum) then
    if objectp(gPanoMovieObj) then
      set tMouseOverResult to gPanoMovieObj(mMouseOver)
      if tMouseOverResult <> 0 then
        set delimmerker to the itemDelimiter
        set the itemDelimiter to ","
        set tAction to item 1 of tMouseOverResult
        if tAction = "jump" then
          set currNID to item 2 of tMouseOverResult
        else
          if tAction = "stil" then
            set currHSID to item 2 of tMouseOverResult
          else
            if tAction = "navg" then
              set thotspotID to item 2 of tMouseOverResult
              set currHSID to thotspotID
              set tViewAngles to gPanoMovieObj(mGetNavgViewAngles)
              set tFileName to gPanoMovieObj(mGetHotSpotName)
              OpenNavMovie(gPathName & "\" & tFileName, 2, 0)
              if objectp(gNavMovieObj) then
                set gPanoFrame to marker(0)
                go("Object From Pano")
                SetNavMovieView(item 1 of tViewAngles, item 2 of tViewAngles)
                ShowNavMovie()
              end if
            else
              if tAction = "misc" then
                set currHSID to item 2 of tMouseOverResult
              else
                if tAction = "undf" then
                  set currHSID to item 2 of tMouseOverResult
                  CheckObjID()
                  set gInfo to 1
                else
                  if tAction = "pan " then
                  end if
                end if
              end if
            end if
          end if
        end if
        set gLastTimeRollover to 1
        set the itemDelimiter to delimmerker
      else
        cursor(200)
        cursor(-1)
        set gLastTimeRollover to 0
      end if
    end if
  else
    if gLastTimeRollover then
      cursor(200)
      cursor(-1)
      set gLastTimeRollover to 0
      if objectp(gPanoMovieObj) then
        gPanoMovieObj(mIdle)
      end if
    end if
  end if
end

on ExtractPathName pPathName
  set tDelimiter to "\"
  if pPathName contains tDelimiter then
    set tCharPos to length(pPathName)
    repeat while tCharPos >= 1
      if char tCharPos of pPathName = tDelimiter then
        return char 1 to tCharPos - 1 of pPathName
      end if
      set tCharPos to tCharPos - 1
    end repeat
    return EMPTY
  else
    return EMPTY
  end if
end

factory SampleCallbacks
method SampleMouseOverHandler
  global gPanoMovieObj
  put "Mouse over panoramic movie"
  if objectp(gPanoMovieObj) then
  end if

method SampleRolloverHandlerD pHotSpotID
  global currHSID
  set currHSID to pHotSpotID

method SampleMouseDownHandlerD
  global gPanoMovieObj, whichmarker, tempmarker
  if objectp(gPanoMovieObj) then
    gPanoMovieObj(mPassMouseDown)
  end if

method SamplePanZoomStartHandler
  put "About to pan or zoom in panoramic movie"

method SampleMouseStillDownHandler
  global gPanoMovieObj
  put "Enter mouse still down from panoramic movie"
  if objectp(gPanoMovieObj) then
  end if
  put "Leave mouse still down from panoramic movie"

method SampleNodeLeaveHandler pToNode
  put "Jumping to node " & pToNode & " in panoramic movie"

factory QTVRCallbacks
method MouseDownD
  global gPanoMovieObj, whichmarker, tempmarker, currHSID
  if whichmarker = "Festung" then
    if currHSID = 3 then
      ClosePanoMovieD()
      set tempmarker to whichmarker
      set whichmarker to "stadt"
      play frame whichmarker
    end if
  end if
  if whichmarker = "Festung" then
    if currHSID = 4 then
      ClosePanoMovieD()
      set tempmarker to whichmarker
      set whichmarker to "stadt"
      play frame whichmarker
    end if
  end if
  if whichmarker = "Festung" then
    if currHSID = 5 then
      ClosePanoMovieD()
      set tempmarker to whichmarker
      set whichmarker to "stadt"
      play frame whichmarker
    end if
  end if
  if whichmarker = "Dom" then
    if currHSID = 1 then
      ClosePanoMovieD()
      set tempmarker to whichmarker
      set whichmarker to "stadt"
      play frame whichmarker
    end if
  end if
  if whichmarker = "Resid" then
    if currHSID = 1 then
      ClosePanoMovieD()
      set tempmarker to whichmarker
      set whichmarker to "stadt"
      play frame whichmarker
    end if
  end if
  gPanoMovieObj(mPassMouseDown)

factory TestCallbacks
method TestMouseOverHandler
  global gPanoMovieObj
  if objectp(gPanoMovieObj) then
    put "In mouse over at: " & the ticks into field "MouseOverHandler Message"
  end if

method TestRolloverHotSpotHandler pHotSpotID
  global gPanoMovieObj
  if objectp(gPanoMovieObj) then
    put "Rolling over hot spot: " & pHotSpotID into field "RolloverHotSpotHandler Message"
  end if

method TestMouseDownHandler
  global gPanoMovieObj
  if objectp(gPanoMovieObj) then
    put "In mouse down at: " & the ticks into field "MouseDownHandler Message"
    gPanoMovieObj(mPassMouseDown)
  end if

method TestPanZoomStartHandler
  global gPanoMovieObj
  if objectp(gPanoMovieObj) then
    put "In pan zoom start at: " & the ticks into field "PanZoomStartHandler Message"
  end if

method TestMouseStillDownHandler
  global gPanoMovieObj
  if objectp(gPanoMovieObj) then
    put "In mouse still down at: " & the ticks into field "MouseStillDownHandler Message"
    put gPanoMovieObj(mGetHPanAngle) into field "MouseStillDownHandler Message"
  end if

method TestNodeLeaveHandler pToNode
  global gPanoMovieObj
  if objectp(gPanoMovieObj) then
    put "Leaving node ID: " & pToNode into field "NodeLeaveHandler Message"
  end if
