on StartMovieVR
  global gQTVRInstance, gPathName, gLastTimeRollover, gTheXtra, gOnPC
  set gQTVRInstance to 0
  set gPathName to EMPTY
  set gLastTimeRollover to 0
  if the machineType = 256 then
    set gOnPC to 1
  end if
  set gTheXtra to xtra("QTVRXtra")
  QTVREnter(gTheXtra)
  set gQTVRInstance to new(gTheXtra)
  if not gOnPC then
    set QTVRCallBackFactory to CallBackTracer(mnew)
    setCallBack(#PanoMovie, QTVRCallBackFactory)
  end if
end

on StopMovieVR
  global gQTVRInstance, gTheXtra
  CloseMovie()
  set gQTVRInstance to 0
  QTVRExit(gTheXtra)
end

on OpenMovie pFileName, pSpriteNum, tShowOnOpen
  global gQTVRInstance, gPathName, gFileName
  CloseMovie()
  set tRect to the left of sprite pSpriteNum & "," & the top of sprite pSpriteNum & "," & the right of sprite pSpriteNum & "," & the bottom of sprite pSpriteNum
  set tResult to QTVROpen(gQTVRInstance, pFileName, tRect, tShowOnOpen)
  if tResult contains "error" then
    exit
  end if
  set gFileName to pFileName
  set gPathName to ExtractPathName(pFileName)
  if QTVRGetQTVRType(gQTVRInstance) = "QTVRPanorama" then
    InitPanoCallbacks()
  end if
end

on CloseMovie
  global gQTVRInstance
  if IsQTVRMovie(gQTVRInstance) then
    QTVRClose(gQTVRInstance)
  end if
end

on SetMovieView pPan, pTilt, pFOV, pQuality
  global gQTVRInstance
  if IsQTVRMovie(gQTVRInstance) then
    if QTVRGetQTVRType(gQTVRInstance) = "QTVRPanorama" then
      QTVRSetFOV(gQTVRInstance, pFOV)
    end if
    QTVRSetTiltAngle(gQTVRInstance, pTilt)
    QTVRSetPanAngle(gQTVRInstance, pPan)
    if not voidp(pQuality) then
      QTVRSetQuality(gQTVRInstance, pQuality)
    end if
  end if
end

on ExtractPathName pPathName
  set tDelimiter to ":"
  if pPathName contains tDelimiter then
    set tCharPos to length(pPathName)
    repeat while tCharPos >= 1
      if char tCharPos of pPathName = tDelimiter then
        return char 1 to tCharPos - 1 of pPathName
      end if
      set tCharPos to tCharPos - 1
    end repeat
    return EMPTY
  else
    return EMPTY
  end if
end

on resetCallbackCheckboxes
  set the hilite of member "MouseOverHandler Check" to 0
  set the hilite of member "RolloverHotSpotHandler Check" to 0
  set the hilite of member "MouseDownHandler Check" to 0
  set the hilite of member "PanZoomStartHandler Check" to 0
  set the hilite of member "MouseStillDownHandler Check" to 0
  set the hilite of member "NodeLeaveHandler Check" to 0
end
